
/*  Version 02 (passebas)
Pan Tilt avec inclinomètre adxl345.
Commande de 2 servos en X et Y

Pin SDA        A4
Pin SCl        A5
Pin Cde Servo  D9
Pin Cde Servo  D10

F5MNA mai/juin 2013
http://f5mna.free.fr

*/
#include <Wire.h>
#include <Servo.h>;  //inclu Servo.h 
Servo Pan;           //Déclaration des servos Pan et Tilt
Servo Tilt;

#define Register_ID 0
#define Register_2D 0x2D
#define Register_X0 0x32
#define Register_X1 0x33
#define Register_Y0 0x34
#define Register_Y1 0x35

int ADXAddress = 0xA7 >> 1;  
int reading = 0;
int X0,X1,X_out;
int Y0,Y1,Y_out;

double Xg,Yg;

//Pass bas
float pbasX;
float precedX = 0;
float inputX;
float pbasY;
float precedY = 0;
float inputY;
float f = 0.2;  // Coef du filtre pass bas


void setup()
{  
 Pan.attach(9);     //assigne pin 9 et 10 pour le signal de sortie destiné à commander les servos
 Tilt.attach(10);
  
  
  Wire.begin();                
  Serial.begin(115200);    
  delay(100);
  // En mesure de prendre ne compte les données g 
  Wire.beginTransmission(ADXAddress);
  Wire.write(Register_2D);
  Wire.write(8);              // mesures 
  Wire.endTransmission();     // stop transmission
}

void loop()
{
  //--------------X
  Wire.beginTransmission(ADXAddress); 
  Wire.write(Register_X0);
  Wire.write(Register_X1);
  Wire.endTransmission();
  Wire.requestFrom(ADXAddress,2); 
  if(Wire.available()<=2)   
  {
    X0 = Wire.read();
    X1 = Wire.read(); 
    X1=X1<<8;
    X_out=X0+X1;   
  }
  //------------------Y
  Wire.beginTransmission(ADXAddress);  
  Wire.write(Register_Y0);
  Wire.write(Register_Y1);
  Wire.endTransmission();
  Wire.requestFrom(ADXAddress,2); 
  if(Wire.available()<=2)   
  {
    Y0 = Wire.read();
    Y1 = Wire.read(); 
    Y1=Y1<<8;
    Y_out=Y0+Y1;
  //-----------------  
  }

  Xg=(X_out/256.0)*100;
  Yg=(Y_out/256.0)*100;
  
  /////////////Passe bas////////////
   pbasX = precedX+ (f * (Xg - precedX));//sortie = sortie précédente + (f * ( entrée - sortie précédente)) 
                                        //La variable f est un nombre entre 0 et 1 qui détermine l'intensité du filtre: 
   precedX = pbasX;
      
   pbasY = precedY+ (f * (Yg - precedY));
                                     
   precedY = pbasY;
  /////////////////////////////////// 
     Serial.print ("  X: ");
     Serial.print(Xg);
     Serial.print("     X regul: ");
     Serial.print (pbasX);
     Serial.print ("     Y: ");
     Serial.print(Yg);
     Serial.print("     Y regul: ");
     Serial.println (pbasY);
   
  Xg = pbasX;
  Yg = pbasY;
  
  Xg = map(Xg, 100, -100, 0, 180);        //Ré-étalonnage: transforme valeurs numérique en degrés (echelle)
  Yg = map(Yg, -100, 100, 0, 180);        

  Pan.write(Xg);                          //Indique aux servos Pan & tilt la valeur en degrés à atteindre
  Tilt.write(Yg); 

 }
